=begin
#Zoom API

#The Zoom API allows developers to safely and securely access information from Zoom. You can use this API to build private services or public applications on the [Zoom App Marketplace](http://marketplace.zoom.us). To learn how to get your credentials and create private/public applications, read our [Authorization Guide](https://marketplace.zoom.us/docs/guides/authorization/credentials). All endpoints are available via `https` and are located at `api.zoom.us/v2/`.  For instance you can list all users on an account via `https://api.zoom.us/v2/users/`.

OpenAPI spec version: 2.0.0
Contact: developersupport@zoom.us
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.12

=end

module ZoomUs
  autoload :Accounts, 'zoom_us/accounts'
  autoload :ApiClient, 'zoom_us/api_client'
  autoload :ApiError, 'zoom_us/api_error'
  autoload :Billing, 'zoom_us/billing'
  autoload :ChatChannels, 'zoom_us/chat_channels'
  autoload :ChatMessages, 'zoom_us/chat_messages'
  autoload :ChatbotMessages, 'zoom_us/chatbot_messages'
  autoload :CloudRecording, 'zoom_us/cloud_recording'
  autoload :CommonAreaPhones, 'zoom_us/common_area_phones'
  autoload :Configuration, 'zoom_us/configuration'
  autoload :Contacts, 'zoom_us/contacts'
  autoload :Dashboards, 'zoom_us/dashboards'
  autoload :Devices, 'zoom_us/devices'
  autoload :Groups, 'zoom_us/groups'
  autoload :IMChat, 'zoom_us/im_chat'
  autoload :IMGroups, 'zoom_us/im_groups'
  autoload :Meetings, 'zoom_us/meetings'
  autoload :Models, 'zoom_us/models'
  autoload :PAC, 'zoom_us/pac'
  autoload :Phone, 'zoom_us/phone'
  autoload :PhoneAutoReceptionists, 'zoom_us/phone_auto_receptionists'
  autoload :PhoneBlockedList, 'zoom_us/phone_blocked_list'
  autoload :PhoneCallQueues, 'zoom_us/phone_call_queues'
  autoload :PhoneDevices, 'zoom_us/phone_devices'
  autoload :PhoneSite, 'zoom_us/phone_site'
  autoload :Reports, 'zoom_us/reports'
  autoload :Roles, 'zoom_us/roles'
  autoload :Rooms, 'zoom_us/rooms'
  autoload :RoomsAccount, 'zoom_us/rooms_account'
  autoload :RoomsLocation, 'zoom_us/rooms_location'
  autoload :SIPConnectedAudio, 'zoom_us/sip_connected_audio'
  autoload :SIPPhone, 'zoom_us/sip_phone'
  autoload :TrackingField, 'zoom_us/tracking_field'
  autoload :TSP, 'zoom_us/tsp'
  autoload :Users, 'zoom_us/users'
  autoload :VERSION, 'zoom_us/version'
  autoload :Webinars, 'zoom_us/webinars'
  class << self
    # Customize default settings for the SDK using block.
    #   ZoomUs.configure do |config|
    #     config.username = "xxx"
    #     config.password = "xxx"
    #   end
    # If no block given, return the default Configuration object.
    def configure
      if block_given?
        yield(Configuration.default)
      else
        Configuration.default
      end
    end
  end
end
