=begin
#Zoom API

#The Zoom API allows developers to safely and securely access information from Zoom. You can use this API to build private services or public applications on the [Zoom App Marketplace](http://marketplace.zoom.us). To learn how to get your credentials and create private/public applications, read our [Authorization Guide](https://marketplace.zoom.us/docs/guides/authorization/credentials). All endpoints are available via `https` and are located at `api.zoom.us/v2/`.  For instance you can list all users on an account via `https://api.zoom.us/v2/users/`.

OpenAPI spec version: 2.0.0
Contact: developersupport@zoom.us
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.12

=end

require 'date'

module ZoomUs
  module Models
    # Meeting live stream.
    class Body42
      # Streaming URL.
      attr_accessor :stream_url

      # Stream name and key.
      attr_accessor :stream_key

      # The livestream page URL.
      attr_accessor :page_url

      # Attribute mapping from ruby-style variable name to JSON key.
      def self.attribute_map
        {
          :'stream_url' => :'stream_url',
          :'stream_key' => :'stream_key',
          :'page_url' => :'page_url'
        }
      end

      # Attribute type mapping.
      def self.swagger_types
        {
          :'stream_url' => :'String',
          :'stream_key' => :'String',
          :'page_url' => :'String'
        }
      end

      # Initializes the object
      # @param [Hash] attributes Model attributes in the form of hash
      def initialize(attributes = {})
        return unless attributes.is_a?(Hash)

        # convert string to symbol for hash key
        attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

        if attributes.has_key?(:'stream_url')
          self.stream_url = attributes[:'stream_url']
        end

        if attributes.has_key?(:'stream_key')
          self.stream_key = attributes[:'stream_key']
        end

        if attributes.has_key?(:'page_url')
          self.page_url = attributes[:'page_url']
        end
      end

      # Show invalid properties with the reasons. Usually used together with valid?
      # @return Array for valid properties with the reasons
      def list_invalid_properties
        invalid_properties = Array.new
        if @stream_url.nil?
          invalid_properties.push('invalid value for "stream_url", stream_url cannot be nil.')
        end

        if @stream_url.to_s.length > 1024
          invalid_properties.push('invalid value for "stream_url", the character length must be smaller than or equal to 1024.')
        end

        if @stream_key.nil?
          invalid_properties.push('invalid value for "stream_key", stream_key cannot be nil.')
        end

        if @stream_key.to_s.length > 512
          invalid_properties.push('invalid value for "stream_key", the character length must be smaller than or equal to 512.')
        end

        if !@page_url.nil? && @page_url.to_s.length > 1024
          invalid_properties.push('invalid value for "page_url", the character length must be smaller than or equal to 1024.')
        end

        invalid_properties
      end

      # Check to see if the all the properties in the model are valid
      # @return true if the model is valid
      def valid?
        return false if @stream_url.nil?
        return false if @stream_url.to_s.length > 1024
        return false if @stream_key.nil?
        return false if @stream_key.to_s.length > 512
        return false if !@page_url.nil? && @page_url.to_s.length > 1024
        true
      end

      # Custom attribute writer method with validation
      # @param [Object] stream_url Value to be assigned
      def stream_url=(stream_url)
        if stream_url.nil?
          fail ArgumentError, 'stream_url cannot be nil'
        end

        if stream_url.to_s.length > 1024
          fail ArgumentError, 'invalid value for "stream_url", the character length must be smaller than or equal to 1024.'
        end

        @stream_url = stream_url
      end

      # Custom attribute writer method with validation
      # @param [Object] stream_key Value to be assigned
      def stream_key=(stream_key)
        if stream_key.nil?
          fail ArgumentError, 'stream_key cannot be nil'
        end

        if stream_key.to_s.length > 512
          fail ArgumentError, 'invalid value for "stream_key", the character length must be smaller than or equal to 512.'
        end

        @stream_key = stream_key
      end

      # Custom attribute writer method with validation
      # @param [Object] page_url Value to be assigned
      def page_url=(page_url)
        if !page_url.nil? && page_url.to_s.length > 1024
          fail ArgumentError, 'invalid value for "page_url", the character length must be smaller than or equal to 1024.'
        end

        @page_url = page_url
      end

      # Checks equality by comparing each attribute.
      # @param [Object] Object to be compared
      def ==(o)
        return true if self.equal?(o)
        self.class == o.class &&
          stream_url == o.stream_url &&
          stream_key == o.stream_key &&
          page_url == o.page_url
      end

      # @see the `==` method
      # @param [Object] Object to be compared
      def eql?(o)
        self == o
      end

      # Calculates hash code according to all attributes.
      # @return [Fixnum] Hash code
      def hash
        [stream_url, stream_key, page_url].hash
      end

      # Builds the object from hash
      # @param [Hash] attributes Model attributes in the form of hash
      # @return [Object] Returns the model itself
      def build_from_hash(attributes)
        return nil unless attributes.is_a?(Hash)
        self.class.swagger_types.each_pair do |key, type|
          if type =~ /\AArray<(.*)>/i
            # check to ensure the input is an array given that the the attribute
            # is documented as an array but the input is not
            if attributes[self.class.attribute_map[key]].is_a?(Array)
              self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
            end
          elsif !attributes[self.class.attribute_map[key]].nil?
            self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
          end # or else data not found in attributes(hash), not an issue as the data can be optional
        end

        self
      end

      # Deserializes the data based on type
      # @param string type Data type
      # @param string value Value to be deserialized
      # @return [Object] Deserialized data
      def _deserialize(type, value)
        case type.to_sym
        when :DateTime
          ::DateTime.parse(value)
        when :Date
          ::Date.parse(value)
        when :String
          value.to_s
        when :Integer
          value.to_i
        when :Float
          value.to_f
        when :BOOLEAN
          if value.to_s =~ /\A(true|t|yes|y|1)\z/i
            true
          else
            false
          end
        when :Object
          # generic object (usually a Hash), return directly
          value
        when /\AArray<(?<inner_type>.+)>\z/
          inner_type = Regexp.last_match[:inner_type]
          value.map { |v| _deserialize(inner_type, v) }
        when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
          k_type = Regexp.last_match[:k_type]
          v_type = Regexp.last_match[:v_type]
          {}.tap do |hash|
            value.each do |k, v|
              hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
            end
          end
        else # model
          temp_model = Models.const_get(type).new
          temp_model.build_from_hash(value)
        end
      end

      # Returns the string representation of the object
      # @return [String] String presentation of the object
      def to_s
        to_hash.to_s
      end

      # to_body is an alias to to_hash (backward compatibility)
      # @return [Hash] Returns the object in the form of hash
      def to_body
        to_hash
      end

      # Returns the object in the form of hash
      # @return [Hash] Returns the object in the form of hash
      def to_hash
        hash = {}
        self.class.attribute_map.each_pair do |attr, param|
          value = self.send(attr)
          next if value.nil?
          hash[param] = _to_hash(value)
        end
        hash
      end

      # Outputs non-array value in the form of hash
      # For object, use to_hash. Otherwise, just return the value
      # @param [Object] value Any valid value
      # @return [Hash] Returns the value in the form of hash
      def _to_hash(value)
        if value.is_a?(Array)
          value.compact.map { |v| _to_hash(v) }
        elsif value.is_a?(Hash)
          {}.tap do |hash|
            value.each { |k, v| hash[k] = _to_hash(v) }
          end
        elsif value.respond_to? :to_hash
          value.to_hash
        else
          value
        end
      end
    end
  end
end
