=begin
#Zoom API

#The Zoom API allows developers to safely and securely access information from Zoom. You can use this API to build private services or public applications on the [Zoom App Marketplace](http://marketplace.zoom.us). To learn how to get your credentials and create private/public applications, read our [Authorization Guide](https://marketplace.zoom.us/docs/guides/authorization/credentials). All endpoints are available via `https` and are located at `api.zoom.us/v2/`.  For instance you can list all users on an account via `https://api.zoom.us/v2/users/`.

OpenAPI spec version: 2.0.0
Contact: developersupport@zoom.us
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.12

=end

require 'date'

module ZoomUs
  module Models
    # Meeting object
    class InlineResponse20110
      # Meeting ID
      attr_accessor :id

      # Meeting topic
      attr_accessor :topic

      # Meeting Type
      attr_accessor :type

      # Meeting start time
      attr_accessor :start_time

      # Meeting duration
      attr_accessor :duration

      # Timezone to format start_time
      attr_accessor :timezone

      # The date and time at which this meeting was created.
      attr_accessor :created_at

      # Agenda
      attr_accessor :agenda

      # Start url
      attr_accessor :start_url

      # Join url
      attr_accessor :join_url

      # Meeting password. Password may only contain the following characters: `[a-z A-Z 0-9 @ - _ * !]`
      attr_accessor :password

      # H.323/SIP room system password
      attr_accessor :h323_password

      # Personal Meeting Id. Only used for scheduled meetings and recurring meetings with no fixed time.
      attr_accessor :pmi

      # Tracking fields
      attr_accessor :tracking_fields

      # Array of occurrence objects.
      attr_accessor :occurrences

      attr_accessor :settings

      attr_accessor :recurrence

      # Attribute mapping from ruby-style variable name to JSON key.
      def self.attribute_map
        {
          :'id' => :'id',
          :'topic' => :'topic',
          :'type' => :'type',
          :'start_time' => :'start_time',
          :'duration' => :'duration',
          :'timezone' => :'timezone',
          :'created_at' => :'created_at',
          :'agenda' => :'agenda',
          :'start_url' => :'start_url',
          :'join_url' => :'join_url',
          :'password' => :'password',
          :'h323_password' => :'h323_password',
          :'pmi' => :'pmi',
          :'tracking_fields' => :'tracking_fields',
          :'occurrences' => :'occurrences',
          :'settings' => :'settings',
          :'recurrence' => :'recurrence'
        }
      end

      # Attribute type mapping.
      def self.swagger_types
        {
          :'id' => :'Integer',
          :'topic' => :'String',
          :'type' => :'Integer',
          :'start_time' => :'DateTime',
          :'duration' => :'Integer',
          :'timezone' => :'String',
          :'created_at' => :'DateTime',
          :'agenda' => :'String',
          :'start_url' => :'String',
          :'join_url' => :'String',
          :'password' => :'String',
          :'h323_password' => :'String',
          :'pmi' => :'Integer',
          :'tracking_fields' => :'Array<UsersuserIdmeetingsTrackingFields>',
          :'occurrences' => :'Array<InlineResponse20110Occurrences>',
          :'settings' => :'InlineResponse20110Settings',
          :'recurrence' => :'UsersuserIdmeetingsRecurrence'
        }
      end

      # Initializes the object
      # @param [Hash] attributes Model attributes in the form of hash
      def initialize(attributes = {})
        return unless attributes.is_a?(Hash)

        # convert string to symbol for hash key
        attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

        if attributes.has_key?(:'topic')
          self.topic = attributes[:'topic']
        end

        if attributes.has_key?(:'type')
          self.type = attributes[:'type']
        end

        if attributes.has_key?(:'start_time')
          self.start_time = attributes[:'start_time']
        end

        if attributes.has_key?(:'duration')
          self.duration = attributes[:'duration']
        end

        if attributes.has_key?(:'timezone')
          self.timezone = attributes[:'timezone']
        end

        if attributes.has_key?(:'created_at')
          self.created_at = attributes[:'created_at']
        end

        if attributes.has_key?(:'agenda')
          self.agenda = attributes[:'agenda']
        end

        if attributes.has_key?(:'start_url')
          self.start_url = attributes[:'start_url']
        end

        if attributes.has_key?(:'join_url')
          self.join_url = attributes[:'join_url']
        end

        if attributes.has_key?(:'password')
          self.password = attributes[:'password']
        end

        if attributes.has_key?(:'h323_password')
          self.h323_password = attributes[:'h323_password']
        end

        if attributes.has_key?(:'pmi')
          self.pmi = attributes[:'pmi']
        end

        if attributes.has_key?(:'tracking_fields')
          if (value = attributes[:'tracking_fields']).is_a?(Array)
            self.tracking_fields = value
          end
        end

        if attributes.has_key?(:'occurrences')
          if (value = attributes[:'occurrences']).is_a?(Array)
            self.occurrences = value
          end
        end

        if attributes.has_key?(:'settings')
          self.settings = attributes[:'settings']
        end

        if attributes.has_key?(:'recurrence')
          self.recurrence = attributes[:'recurrence']
        end
      end

      # Show invalid properties with the reasons. Usually used together with valid?
      # @return Array for valid properties with the reasons
      def list_invalid_properties
        invalid_properties = Array.new
        invalid_properties
      end

      # Check to see if the all the properties in the model are valid
      # @return true if the model is valid
      def valid?
        true
      end

      # Checks equality by comparing each attribute.
      # @param [Object] Object to be compared
      def ==(o)
        return true if self.equal?(o)
        self.class == o.class &&
          topic == o.topic &&
          type == o.type &&
          start_time == o.start_time &&
          duration == o.duration &&
          timezone == o.timezone &&
          created_at == o.created_at &&
          agenda == o.agenda &&
          start_url == o.start_url &&
          join_url == o.join_url &&
          password == o.password &&
          h323_password == o.h323_password &&
          pmi == o.pmi &&
          tracking_fields == o.tracking_fields &&
          occurrences == o.occurrences &&
          settings == o.settings &&
          recurrence == o.recurrence
      end

      # @see the `==` method
      # @param [Object] Object to be compared
      def eql?(o)
        self == o
      end

      # Calculates hash code according to all attributes.
      # @return [Fixnum] Hash code
      def hash
        [topic, type, start_time, duration, timezone, created_at, agenda, start_url, join_url, password, h323_password, pmi, tracking_fields, occurrences, settings, recurrence].hash
      end

      # Builds the object from hash
      # @param [Hash] attributes Model attributes in the form of hash
      # @return [Object] Returns the model itself
      def build_from_hash(attributes)
        return nil unless attributes.is_a?(Hash)
        self.class.swagger_types.each_pair do |key, type|
          if type =~ /\AArray<(.*)>/i
            # check to ensure the input is an array given that the the attribute
            # is documented as an array but the input is not
            if attributes[self.class.attribute_map[key]].is_a?(Array)
              self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
            end
          elsif !attributes[self.class.attribute_map[key]].nil?
            self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
          end # or else data not found in attributes(hash), not an issue as the data can be optional
        end

        self
      end

      # Deserializes the data based on type
      # @param string type Data type
      # @param string value Value to be deserialized
      # @return [Object] Deserialized data
      def _deserialize(type, value)
        case type.to_sym
        when :DateTime
          ::DateTime.parse(value)
        when :Date
          ::Date.parse(value)
        when :String
          value.to_s
        when :Integer
          value.to_i
        when :Float
          value.to_f
        when :BOOLEAN
          if value.to_s =~ /\A(true|t|yes|y|1)\z/i
            true
          else
            false
          end
        when :Object
          # generic object (usually a Hash), return directly
          value
        when /\AArray<(?<inner_type>.+)>\z/
          inner_type = Regexp.last_match[:inner_type]
          value.map { |v| _deserialize(inner_type, v) }
        when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
          k_type = Regexp.last_match[:k_type]
          v_type = Regexp.last_match[:v_type]
          {}.tap do |hash|
            value.each do |k, v|
              hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
            end
          end
        else # model
          temp_model = Models.const_get(type).new
          temp_model.build_from_hash(value)
        end
      end

      # Returns the string representation of the object
      # @return [String] String presentation of the object
      def to_s
        to_hash.to_s
      end

      # to_body is an alias to to_hash (backward compatibility)
      # @return [Hash] Returns the object in the form of hash
      def to_body
        to_hash
      end

      # Returns the object in the form of hash
      # @return [Hash] Returns the object in the form of hash
      def to_hash
        hash = {}
        self.class.attribute_map.each_pair do |attr, param|
          value = self.send(attr)
          next if value.nil?
          hash[param] = _to_hash(value)
        end
        hash
      end

      # Outputs non-array value in the form of hash
      # For object, use to_hash. Otherwise, just return the value
      # @param [Object] value Any valid value
      # @return [Hash] Returns the value in the form of hash
      def _to_hash(value)
        if value.is_a?(Array)
          value.compact.map { |v| _to_hash(v) }
        elsif value.is_a?(Hash)
          {}.tap do |hash|
            value.each { |k, v| hash[k] = _to_hash(v) }
          end
        elsif value.respond_to? :to_hash
          value.to_hash
        else
          value
        end
      end
    end
  end
end
