=begin
#Zoom API

#The Zoom API allows developers to safely and securely access information from Zoom. You can use this API to build private services or public applications on the [Zoom App Marketplace](http://marketplace.zoom.us). To learn how to get your credentials and create private/public applications, read our [Authorization Guide](https://marketplace.zoom.us/docs/guides/authorization/credentials). All endpoints are available via `https` and are located at `api.zoom.us/v2/`.  For instance you can list all users on an account via `https://api.zoom.us/v2/users/`.

OpenAPI spec version: 2.0.0
Contact: developersupport@zoom.us
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.12

=end

require 'date'

module ZoomUs
  module Models
    class InlineResponse20118
      # Webinar agenda.
      attr_accessor :agenda

      # Create time.
      attr_accessor :created_at

      # Webinar duration.
      attr_accessor :duration

      # ID of the user set as host of the webinar.
      attr_accessor :host_id

      # Webinar ID, also known as the webinar number.
      attr_accessor :id

      # Join URL.
      attr_accessor :join_url

      # Array of occurrence objects.
      attr_accessor :occurrences

      attr_accessor :recurrence

      attr_accessor :settings

      # Webinar start time.
      attr_accessor :start_time

      # <br><aside>The <code>start_url</code> of a Webinar is a URL using which a host or an alternative host can start the Webinar.   The expiration time for the <code>start_url</code> field listed in the response of [Create a Webinar API](https://marketplace.zoom.us/docs/api-reference/zoom-api/webinars/webinarcreate) is two hours for all regular users.    For users created using the <code>custCreate</code> option via the [Create Users](https://marketplace.zoom.us/docs/api-reference/zoom-api/users/usercreate) API, the expiration time of the <code>start_url</code> field is 90 days.   For security reasons, to retrieve the latest value for the <code>start_url</code> field programmatically (after expiry), you must call the [Retrieve a Webinar API](https://marketplace.zoom.us/docs/api-reference/zoom-api/webinars/webinar) and refer to the value of the <code>start_url</code> field in the response.</aside><br><br><br>
      attr_accessor :start_url

      # Time zone to format start_time.
      attr_accessor :timezone

      # Webinar topic.
      attr_accessor :topic

      # Tracking fields
      attr_accessor :tracking_fields

      # Webinar Types:<br>`5` - Webinar.<br>`6` - Recurring webinar with no fixed time.<br>`9` - Recurring webinar with a fixed time.
      attr_accessor :type

      # Unique identifier for a Webinar. Each webinar instance will generate its own UUID. Once a Webinar ends, the value of uuid for the same webinar will be different from when it was scheduled.
      attr_accessor :uuid

      # Attribute mapping from ruby-style variable name to JSON key.
      def self.attribute_map
        {
          :'agenda' => :'agenda',
          :'created_at' => :'created_at',
          :'duration' => :'duration',
          :'host_id' => :'host_id',
          :'id' => :'id',
          :'join_url' => :'join_url',
          :'occurrences' => :'occurrences',
          :'recurrence' => :'recurrence',
          :'settings' => :'settings',
          :'start_time' => :'start_time',
          :'start_url' => :'start_url',
          :'timezone' => :'timezone',
          :'topic' => :'topic',
          :'tracking_fields' => :'tracking_fields',
          :'type' => :'type',
          :'uuid' => :'uuid'
        }
      end

      # Attribute type mapping.
      def self.swagger_types
        {
          :'agenda' => :'String',
          :'created_at' => :'DateTime',
          :'duration' => :'Integer',
          :'host_id' => :'String',
          :'id' => :'Integer',
          :'join_url' => :'String',
          :'occurrences' => :'Array<InlineResponse20110Occurrences>',
          :'recurrence' => :'RecurrenceWebinar',
          :'settings' => :'InlineResponse20118Settings',
          :'start_time' => :'DateTime',
          :'start_url' => :'String',
          :'timezone' => :'String',
          :'topic' => :'String',
          :'tracking_fields' => :'Array<UsersuserIdmeetingsTrackingFields>',
          :'type' => :'Integer',
          :'uuid' => :'String'
        }
      end

      # Initializes the object
      # @param [Hash] attributes Model attributes in the form of hash
      def initialize(attributes = {})
        return unless attributes.is_a?(Hash)

        # convert string to symbol for hash key
        attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

        if attributes.has_key?(:'agenda')
          self.agenda = attributes[:'agenda']
        end

        if attributes.has_key?(:'created_at')
          self.created_at = attributes[:'created_at']
        end

        if attributes.has_key?(:'duration')
          self.duration = attributes[:'duration']
        end

        if attributes.has_key?(:'host_id')
          self.host_id = attributes[:'host_id']
        end

        if attributes.has_key?(:'id')
          self.id = attributes[:'id']
        end

        if attributes.has_key?(:'join_url')
          self.join_url = attributes[:'join_url']
        end

        if attributes.has_key?(:'occurrences')
          if (value = attributes[:'occurrences']).is_a?(Array)
            self.occurrences = value
          end
        end

        if attributes.has_key?(:'recurrence')
          self.recurrence = attributes[:'recurrence']
        end

        if attributes.has_key?(:'settings')
          self.settings = attributes[:'settings']
        end

        if attributes.has_key?(:'start_time')
          self.start_time = attributes[:'start_time']
        end

        if attributes.has_key?(:'start_url')
          self.start_url = attributes[:'start_url']
        end

        if attributes.has_key?(:'timezone')
          self.timezone = attributes[:'timezone']
        end

        if attributes.has_key?(:'topic')
          self.topic = attributes[:'topic']
        end

        if attributes.has_key?(:'tracking_fields')
          if (value = attributes[:'tracking_fields']).is_a?(Array)
            self.tracking_fields = value
          end
        end

        if attributes.has_key?(:'type')
          self.type = attributes[:'type']
        end

        if attributes.has_key?(:'uuid')
          self.uuid = attributes[:'uuid']
        end
      end

      # Show invalid properties with the reasons. Usually used together with valid?
      # @return Array for valid properties with the reasons
      def list_invalid_properties
        invalid_properties = Array.new
        invalid_properties
      end

      # Check to see if the all the properties in the model are valid
      # @return true if the model is valid
      def valid?
        true
      end

      # Checks equality by comparing each attribute.
      # @param [Object] Object to be compared
      def ==(o)
        return true if self.equal?(o)
        self.class == o.class &&
          agenda == o.agenda &&
          created_at == o.created_at &&
          duration == o.duration &&
          host_id == o.host_id &&
          id == o.id &&
          join_url == o.join_url &&
          occurrences == o.occurrences &&
          recurrence == o.recurrence &&
          settings == o.settings &&
          start_time == o.start_time &&
          start_url == o.start_url &&
          timezone == o.timezone &&
          topic == o.topic &&
          tracking_fields == o.tracking_fields &&
          type == o.type &&
          uuid == o.uuid
      end

      # @see the `==` method
      # @param [Object] Object to be compared
      def eql?(o)
        self == o
      end

      # Calculates hash code according to all attributes.
      # @return [Fixnum] Hash code
      def hash
        [agenda, created_at, duration, host_id, id, join_url, occurrences, recurrence, settings, start_time, start_url, timezone, topic, tracking_fields, type, uuid].hash
      end

      # Builds the object from hash
      # @param [Hash] attributes Model attributes in the form of hash
      # @return [Object] Returns the model itself
      def build_from_hash(attributes)
        return nil unless attributes.is_a?(Hash)
        self.class.swagger_types.each_pair do |key, type|
          if type =~ /\AArray<(.*)>/i
            # check to ensure the input is an array given that the the attribute
            # is documented as an array but the input is not
            if attributes[self.class.attribute_map[key]].is_a?(Array)
              self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
            end
          elsif !attributes[self.class.attribute_map[key]].nil?
            self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
          end # or else data not found in attributes(hash), not an issue as the data can be optional
        end

        self
      end

      # Deserializes the data based on type
      # @param string type Data type
      # @param string value Value to be deserialized
      # @return [Object] Deserialized data
      def _deserialize(type, value)
        case type.to_sym
        when :DateTime
          ::DateTime.parse(value)
        when :Date
          ::Date.parse(value)
        when :String
          value.to_s
        when :Integer
          value.to_i
        when :Float
          value.to_f
        when :BOOLEAN
          if value.to_s =~ /\A(true|t|yes|y|1)\z/i
            true
          else
            false
          end
        when :Object
          # generic object (usually a Hash), return directly
          value
        when /\AArray<(?<inner_type>.+)>\z/
          inner_type = Regexp.last_match[:inner_type]
          value.map { |v| _deserialize(inner_type, v) }
        when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
          k_type = Regexp.last_match[:k_type]
          v_type = Regexp.last_match[:v_type]
          {}.tap do |hash|
            value.each do |k, v|
              hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
            end
          end
        else # model
          temp_model = Models.const_get(type).new
          temp_model.build_from_hash(value)
        end
      end

      # Returns the string representation of the object
      # @return [String] String presentation of the object
      def to_s
        to_hash.to_s
      end

      # to_body is an alias to to_hash (backward compatibility)
      # @return [Hash] Returns the object in the form of hash
      def to_body
        to_hash
      end

      # Returns the object in the form of hash
      # @return [Hash] Returns the object in the form of hash
      def to_hash
        hash = {}
        self.class.attribute_map.each_pair do |attr, param|
          value = self.send(attr)
          next if value.nil?
          hash[param] = _to_hash(value)
        end
        hash
      end

      # Outputs non-array value in the form of hash
      # For object, use to_hash. Otherwise, just return the value
      # @param [Object] value Any valid value
      # @return [Hash] Returns the value in the form of hash
      def _to_hash(value)
        if value.is_a?(Array)
          value.compact.map { |v| _to_hash(v) }
        elsif value.is_a?(Hash)
          {}.tap do |hash|
            value.each { |k, v| hash[k] = _to_hash(v) }
          end
        elsif value.respond_to? :to_hash
          value.to_hash
        else
          value
        end
      end
    end
  end
end
